#ifndef lariat_artdaq_ArtModules_ModuleUtils_hh
#define lariat_artdaq_ArtModules_ModuleUtils_hh

// JCF, 5/8/14

// ModuleUtils is a utility module which provides the
// getLariatFragments function. This function will take an
// artdaq::Fragment object, an enumerated Lariat fragment type, and a
// vector of pointers; it will search the artdaq::Fragment's payload
// for Lariat fragments of the requested type, and return pointers to
// all locations in the payload it found them. Useful for modules
// which are designed to analyze a specific Lariat fragment type, but
// which was passed an artdaq::Fragment which contails multiple Lariat
// fragments -- e.g., all the data from all detectors in a given spill


#include "art/Framework/Core/ModuleMacros.h"
#include "art/Framework/Principal/Event.h"
#include "art/Framework/Principal/Handle.h"

#include "art/Utilities/Exception.h"
#include "artdaq-core/Data/Fragments.hh"

#include "include/LariatFragment.h"

#include <algorithm>
#include <cassert>
#include <cmath>
#include <fstream>
#include <iomanip>
#include <vector>
#include <iostream>


namespace lariat {

  void getLariatFragments(const artdaq::Fragment& artdaqFrag, 
			  LariatFragment::LariatFragmentType desiredFragType,
			  std::vector<const uint8_t*>& lariatPtrs
			  );
}

#endif // lariat_artdaq_ArtModules_ModuleUtils_hh 
