#ifndef lariat_artdaq_Overlays_CAENADCFragment_hh
#define lariat_artdaq_Overlays_CAENADCFragment_hh

#include "GenericFragment.hh"
#include "include/CAENFragment.h"


#include <iostream>

// Implementation of "CAENADCFragment", an artdaq::Fragment overlay class
// to be used by the CAEN boards (V1740, V1751..) in the Lariat experiment

namespace lariat {
  class CAENADCFragment;

  typedef GenericFragment<CAENFragment::CaenHeader, uint16_t> CAENADCFragmentBase;

}

class lariat::CAENADCFragment : lariat::CAENADCFragmentBase {

  public:

  using lariat::CAENADCFragmentBase::getHeader;
  using lariat::CAENADCFragmentBase::dataBegin;
  using lariat::CAENADCFragmentBase::dataEnd;
  using lariat::CAENADCFragmentBase::total_values;


  CAENADCFragment(const uint8_t* const ptr ) : 
    lariat::CAENADCFragmentBase( ptr ) {}


  void printHeader() const {
    std::cout << std::endl;
    std::cout << "Fragment size: " << getHeader()->fragmentSize << std::endl;
    std::cout << "Fragment type: " << getHeader()->fragmentType << std::endl;
    std::cout << "Event counter: " << getHeader()->eventCounter << std::endl;
    std::cout << "Event size: " << getHeader()->eventSize << std::endl ;
    std::cout << "Board ID: " << getHeader()->boardId << std::endl;
    std::cout << "Pattern: " << getHeader()->pattern << std::endl;
    std::cout << "Trigger time tag: " << getHeader()->triggerTimeTag << std::endl;
    std::cout << "Channel mask: " << getHeader()->channelMask << std::endl ;
    std::cout << "# channels: " << getHeader()->nChannels << std::endl ;
    std::cout << "# samples: " << getHeader()->nSamples << std::endl ;
    std::cout << "Timestamp (s): " << getHeader()->timeStampSec << std::endl ;
    std::cout << "Timestamp (ns): " << getHeader()->timeStampNSec << std::endl ;
    std::cout << std::endl;
  }

/*
  int CAENTimestamp() const{

    return static_cast<int>(getHeader()->timeStampSec );

  }

  int CAENID() const{

    return static_cast<int>(getHeader()->boardId );

  }

*/

};

#endif /* lariat_artdaq_Overlays_CAENADCFragment_hh */
