////////////////////////////////////////////////////////////////////////
// Class:       EVB
// Module Type: analyzer
// File:        EVB_module.cc
// Description: Prints out information about each event.
//based on WVFViewer, TDCDump and 1495 and WUTDump... modules by J.F.Freeman
////////////////////////////////////////////////////////////////////////
/*
-fragment/board/spill 
-fragment id corresponds to v1740
- . !!:$ previous command and last token in previous
-lariarReset 0 1
2510_3 used for tests

*/
#include "art/Framework/Core/EDAnalyzer.h"
#include "art/Framework/Core/ModuleMacros.h"
#include "art/Framework/Principal/Event.h"
#include "art/Framework/Principal/Handle.h"

#include "art/Framework/Principal/Run.h"
#include "art/Utilities/InputTag.h"
//#include "art/Framework/Core/ModuleMacros.h"
//#include "art/Framework/Services/Optional/TFileService.h"

#include "ModuleUtils.hh"

#include "art/Utilities/Exception.h"
#include "lariat-artdaq/Overlays/WUTHitFragment.hh"
#include "artdaq-core/Data/Fragments.hh"
#include "include/WUTFragment.h"




#include "art/Utilities/Exception.h"
#include "lariat-artdaq/Overlays/TDCEventFragment.hh"
#include "lariat-artdaq/Overlays/TDCSpillFragment.hh"
#include "lariat-artdaq/Overlays/TDCControllerFragment.hh"
#include "lariat-artdaq/Overlays/V1495HitFragment.hh"
#include "lariat-artdaq/Overlays/FragmentType.hh"
//#include "lariat-artdaq/Overlays/ToyFragment.hh"
#include "lariat-artdaq/Overlays/CAENADCFragment.hh"
#include "include/LariatFragment.h"
#include "lariat-artdaq/Generators/SpillFileReader.hh"
#include "include/TDCFragment.h"
#include "include/TDCDriver.h"
#include "cetlib/exception.h"

#include "TRootCanvas.h"
#include "TCanvas.h"
#include "TGraph.h"
#include "TAxis.h"
#include "TH1D.h"
#include "TH2D.h"
#include "TStyle.h"
#include "TFile.h"
#include "TMath.h"
#include "TTree.h"
#include "TObject.h"
//#include "TSpectrum.h"

#include <stdint.h>
#include <stdio.h>
#include <time.h> 
#include <ctime>
#include <cassert>
#include <cmath>
#include <fstream>
#include <ostream>
#include <istream>
#include <iomanip>
#include <numeric>
#include <vector>
#include <functional>
#include <algorithm>
#include <iostream>
#include <sstream>
#include <streambuf>
#include <initializer_list>
#include <limits>
#include <unordered_set>

#include <cstdlib>
#include <stdint.h>
using std::cout;
using std::cerr;
using std::endl;

namespace lariat {
  //class EVB;


class EVB : public art::EDAnalyzer {
public:
  explicit EVB(fhicl::ParameterSet const & pset);
  virtual ~EVB();

  virtual void analyze(art::Event const & e);

private:

std::unique_ptr<TCanvas> canvas_[2];
    std::vector<Double_t> x_;
    int prescale_;
    bool digital_sum_only_;
    art::RunNumber_t current_run_;
    std::size_t nSamples_;
    std::size_t nChannels_;
	//MODIFIED

bool filltree=false;
TFile* f;
TTree *t;
Int_t TDCNR=0;
Double_t TDCTime=0.;
uint64_t TDCTimeInt=0;
uint64_t TDCControllerTimeInt=0;
uint64_t TDCTime_3=0;
uint64_t TDCNewTimeInt=0;
Double_t TDCNewTime=0;
Int_t TDCFragType=-1;
Int_t NTDCs=0;
Int_t TDCTrigCounts=0;
Int_t TDCControllerNumber=0;
Int_t TDCSpillCounter=0;
Double_t TDCControllerTime=0.;
Int_t TDCStatus=0;
Int_t TDCLinkStatus=0;
Int_t CAENFragType=-1;
Int_t CAENID=-1;
Int_t CAENUnixTime=0;
Double_t CAENTrigTimeTag=0;
Int_t CAENChannels=0;
Int_t CAENSamples=0;
Int_t CAENTimeDiff=0;
std::vector<Float_t> CAENADC;
Int_t WUTFragType=-1;
Int_t time_difference=20;
Double_t WUTTime=0.;
Float_t WUTHitCh=0.0;
Float_t window_low=0.0;
Float_t window_high=0.0;
std::vector<Float_t> WUTHitTime0;
std::vector<Float_t> WUTHitTime1;
std::vector<Float_t> WUTHitTime2;
std::vector<Float_t> WUTHitTime3;
std::vector<Float_t> WUTHitTime4;
std::vector<Float_t> WUTHitTime5;
std::vector<Float_t> WUTHitTime6;
std::vector<Float_t> WUTHitTime7;
std::vector<Float_t> WUTHitTime8;
std::vector<Float_t> WUTHitTime9;
std::vector<Float_t> WUTHitTime10;
std::vector<Float_t> WUTHitTime11;
std::vector<Float_t> WUTHitTime12;
std::vector<Float_t> WUTHitTime13;
std::vector<Float_t> WUTHitTime14;
std::vector<Float_t> WUTHitTime15;
std::vector<Float_t> TimeWindows;
  enum
  {
    TIME_WINDOW = 15
  };
Int_t WUTHits=0;

Int_t v1495FragType=-1;
Int_t v1495Channels=0;
Int_t v1495TrigPatterns=0;
Int_t v1495VetoPatterns=0;


std::vector<std::vector<std::vector<int>>> _tdchitsX;
std::vector<std::vector<std::vector<int>>> _tdchitsY;
std::vector<double> _tdcHitTime;
  TH1D * tdcHits [TDCFragment::MAX_TDCS];
    TH1D * tdcHitssum [TDCFragment::MAX_TDCS];
        TH1D * tdcHitWindows [TDCFragment::MAX_TDCS];
  std::vector<std::shared_ptr<TH2D>> _tdcXY;
    //std::vector<std::shared_ptr<TH2D>> _tdcXYsum;
      TH2D * _tdcXYsum [4];

 time_t time_now;
  struct tm * timeinfo;
  char time_ch [80];
    std::size_t totalEventsSeen;
    std::unordered_set<uint32_t> eventsSeenInSpill;
    std::vector<std::string> fragment_type_labels_;
    std::vector<artdaq::Fragment::fragment_id_t> fragment_ids_;

    std::string histos_filename_;
    std::map<artdaq::Fragment::fragment_id_t, std::size_t> id_to_index_;
std::string file_name_backup;
std::string tree_name;
  std::string raw_data_label_;
  std::string event_frag_type_;

//TDC
  
  std::string controller_frag_type_;
  std::string spill_frag_type_;
//TDC
};

}
lariat::EVB::EVB (fhicl::ParameterSet const & ps):
 art::EDAnalyzer(ps),
  prescale_(ps.get<int> ("prescale")), 
  digital_sum_only_(ps.get<bool> ("digital_sum_only", false)), 
  current_run_(0), 
  nSamples_(1536),
  nChannels_(64),
  _tdchitsX(4),
  _tdchitsY(4),
    _tdcHitTime(16),
  _tdcXY(4),

  totalEventsSeen(0),
  fragment_type_labels_(ps.get<std::vector<std::string>>("fragment_type_labels")),
  histos_filename_(ps.get<std::string>("histos_filename","EVB_histos.root")),
  file_name_backup(ps.get<std::string>("histos_filename","EVB_histos.root")),
  tree_name("lariat_data_event_"),
  raw_data_label_(ps.get<std::string>("raw_data_label"))
{



 sort( fragment_type_labels_.begin(), fragment_type_labels_.end() );
  fragment_type_labels_.erase( unique( fragment_type_labels_.begin(), fragment_type_labels_.end() ), fragment_type_labels_.end() );
  for ( int i=0; i<TDCFragment::MAX_TDCS; i++)
  {
    char title[256];
    sprintf(title,"TDChits%d", (i+1));
    tdcHits[i] = new TH1D(title,title,350,-0.5,349.5);
     //sprintf(title,"TDCtrigs%d", (i+1));
    //tdcTime[i] = new TH1D(title,title,100,0,5);

    sprintf(title,"TDChits_sum_%d", (i+1));
    tdcHitssum[i] = new TH1D(title,title,350,-0.5,349.5);
    
        sprintf(title,"TDChits_window_%d", (i+1));
    tdcHitWindows[i] = new TH1D(title,title,350,-0.5,349.5);

  }
  
      for(int ind2=0;ind2<4;ind2++){
      _tdcXYsum[ind2]= new TH2D( Form("tdc_plane_%d_sum_xy", ind2), "",
								      128, -0.5, 
								      128 - 0.5, 128,
								      -0.5, 128 - 0.5 ) ;
}

}

lariat::EVB::~EVB()
{


}

void lariat::EVB::analyze(art::Event const & e)
{
/*const uint8_t* bytePtr = reinterpret_cast<const uint8_t*>( &*artdaqFrag.dataBegin() );
const std::string * rawString = new std::string(reinterpret_cast<const char*>(bytePtr));
std::istream rawStream(rawString);*/
	art::Handle<artdaq::Fragments> raw;
    std::vector<const uint8_t*> lariatFragPtrs;
	e.getByLabel("daq", "SPILL", raw);
	//new approach
	const artdaq::Fragment& artdaqFrag = (*raw)[0];
  const char * bytePtr = reinterpret_cast<const char *>( &*artdaqFrag.dataBegin() );
 LariatFragment * data = new LariatFragment((char *)bytePtr,
					    artdaqFrag.dataSize()*sizeof(unsigned long long));
 std::cout << "Have data fragment " << artdaqFrag.dataSize()*sizeof(unsigned long long) << std::endl;
 data->print();

  if ( !raw.isValid() || raw->size() != 1) {

    throw cet::exception("Error in WFViewer_module: expected one and only one spill fragment");

  } else {
    const auto& spillfrag((*raw)[0]);
    auto lariatFragType = 
      LariatFragment::LariatFragmentType::FRAGMENT_TYPE_RUNINFO ;

    getLariatFragments(spillfrag, lariatFragType, lariatFragPtrs);

    if (lariatFragPtrs.size() != 1) {
      std::cerr << "Found " << lariatFragPtrs.size() << " Run fragments" << std::endl;
      throw cet::exception("Error in WFViewer: expected one and only one Run fragment");
    }

    GenericFragment<LariatFragment::RunInfo> runInfo( lariatFragPtrs[0] );

    auto runNumber = runInfo.getHeader()->runNumber;

    lariatFragPtrs.clear();
	
//got run number
	std::cout<<"preliminary event dump module "<<std::endl;

	histos_filename_=file_name_backup;
	time (&time_now);
	timeinfo = localtime (&time_now);
	strftime (time_ch,80,"%F_%H",timeinfo);//%F_%H_%M
	int spnumber = int(runNumber);

	std::ostringstream temp_str; 
	temp_str << spnumber;
	histos_filename_.insert(0,temp_str.str());
	histos_filename_.insert(5,time_ch);

	e.event();

	//static std::size_t evt_cntr = -1;
	//evt_cntr++;
	//std::cout<<"event "<<e.event()<<" run "<<e.run()<<" subrun "<<e.subRun()<<std::endl;
//std::cout<<" !!!!!!! run number "<<e.getRun().id()<<" "<<e.getRun().run()<<" "<<e.run()<<" in file "<<filename_read_<<std::endl;
}//raw is valid - check for the run info
	art::EventNumber_t spillNumber = e.event();
	/*int spnumber = int(spillNumber);

	std::ostringstream temp_str; 
	temp_str << spnumber;
	tree_name.insert(19,temp_str.str());
	tree_name.insert(0,time_ch);*/
	TFile *f = new TFile(histos_filename_.c_str(), "UPDATE");
	TTree *t = new TTree(Form("lariat_data_event_%d", int(spillNumber)),"event tree");
//TTree *t = new TTree("lariat_data_event","event tree");
	//TTree *t = new TTree(tree_name.c_str(),"event tree");

	t->Branch("caen_fragtype", &CAENFragType, "CAENFragType/I");
	t->Branch("caen_ID", &CAENID, "CAENID/I");
	t->Branch("caen_unix_timestamp", &CAENUnixTime, "CAENUnixTime/I");
	t->Branch("caen_trigtimetag", &CAENTrigTimeTag, "CAENTrigTimeTag/D");
	t->Branch("caen_channels", &CAENChannels, "CAENChannels/I");
	t->Branch("caen_samples", &CAENSamples, "CAENSamples/I");
	t->Branch("caen_adc_counts", &CAENADC);
	//t->Branch("caen_timediff", &CAENTimeDiff, "CAENTimeDiff/I");

	t->Branch("tdcnr", &TDCNR, "TDCNR/I");
	t->Branch("tdc_timestamp", &TDCTime, "TDCTime/D");
	t->Branch("tdc_controller_timestamp", &TDCControllerTime, "TDCControllerTime/D");
	t->Branch("tdc_fragtype", &TDCFragType, "TDCFragType/I");
	t->Branch("tdc_n", &NTDCs, "NTDCs/I");
	t->Branch("tdc_trigger_counts", &TDCTrigCounts, "TDCTrigCounts/I");
	t->Branch("tdc_controller_number", &TDCControllerNumber, "TDCControllerNumber/I");
	t->Branch("tdc_spill_counter", &TDCSpillCounter, "TDCSpillCounter/I");
	t->Branch("tdc_status", &TDCStatus, "TDCStatus/I");
	t->Branch("tdc_link_status", &TDCLinkStatus, "TDCLinkStatus/I");
	t->Branch("tdc_newtime", &TDCNewTime, "TDCNewTime/D");
	t->Branch("tdc_hit_time", &_tdcHitTime);
	t->Branch("wut_fragtype", &WUTFragType, "WUTFragType/I");
	t->Branch("wut_headertime", &WUTTime, "WUTTime/D");
	t->Branch("wut_hitsnumber", &WUTHits, "WUTHits/I");
	t->Branch("wut_hit_time_ch0", &WUTHitTime0);
	t->Branch("wut_hit_time_ch1", &WUTHitTime1);
	t->Branch("wut_hit_time_ch2", &WUTHitTime2);
	t->Branch("wut_hit_time_ch3", &WUTHitTime3);
	t->Branch("wut_hit_time_ch4", &WUTHitTime4);
	t->Branch("wut_hit_time_ch5", &WUTHitTime5);
	t->Branch("wut_hit_time_ch6", &WUTHitTime6);
	t->Branch("wut_hit_time_ch7", &WUTHitTime7);
	t->Branch("wut_hit_time_ch8", &WUTHitTime8);
	t->Branch("wut_hit_time_ch9", &WUTHitTime9);
	t->Branch("wut_hit_time_ch10", &WUTHitTime10);
	t->Branch("wut_hit_time_ch11", &WUTHitTime11);
	t->Branch("wut_hit_time_ch12", &WUTHitTime12);
	t->Branch("wut_hit_time_ch13", &WUTHitTime13);
	t->Branch("wut_hit_time_ch14", &WUTHitTime14);
	t->Branch("wut_hit_time_ch15", &WUTHitTime15);
	t->Branch("v1495_fragtype", &v1495FragType, "v1495FragType/I");
	t->Branch("v1495_channels", &v1495Channels, "v1495Channels/I");
	t->Branch("v1495_trigpatterns", &v1495TrigPatterns, "v1495TrigPatterns/I");
	t->Branch("v1495_vetopatterns", &v1495VetoPatterns, "v1495VetoPatterns/I");
	//std::size_t total_adc_values = nSamples_ * nChannels_;



	f->cd();
	filltree=false;
  if ( !raw.isValid() || raw->size() != 1) {

    throw cet::exception("Error in EVB_module: expected one and only one spill fragment");

  } else {
//COMMENTED TO USE NEW DATA ACCESS
    eventsSeenInSpill.clear();
/*    const auto& spillfrag((*raw)[0]);

    std::vector<const uint8_t*> lariatFragPtrs;

    const LariatFragment::LariatFragmentType lariatFragType = 
      LariatFragment::LariatFragmentType::FRAGMENT_TYPE_CAEN_ADC ;

    getLariatFragments(spillfrag,
                       lariatFragType,
                       lariatFragPtrs
                       );

    std::cout << std::endl;
    std::cout << "Run " << e.run() << ", subrun " << e.subRun()
              << ", spill " << spillNumber << " has " << lariatFragPtrs.size()
              << " fragment(s) of type CAEN ADC " << lariatFragType << std::endl;


if (lariatFragPtrs.size()>0) filltree=true;



    for (auto fragPtr : lariatFragPtrs) {
    
      const CAENADCFragment* caenPtr = new CAENADCFragment(reinterpret_cast<const uint8_t*>(fragPtr ));

      uint32_t eventCounter = caenPtr->getHeader()->eventCounter;

      auto got = eventsSeenInSpill.find( eventCounter );

      if ( got == eventsSeenInSpill.end() ) {
	eventsSeenInSpill.emplace( eventCounter );
	totalEventsSeen++;
      }


      if ( caenPtr->total_values() != total_adc_values ) {
	throw cet::exception("Error in WFViewer: unexpected number of ADC values found in fragment");
      }
      */
//COMMENTED TO USE NEW DATA ACCESS - END
    const int nfrag=data->caenFrags.size();
  std::cout<<"Found "<<nfrag<<" CAEN fragments"<<std::endl;
    	  if (nfrag>0) filltree=true;
 for ( auto &i: data->caenFrags )
 {
   //    cout<<"boardID="<<i.header.boardId<<endl;

    
  
    //	std::cout<<int(double(i.header.timeStampSec))<<" CAEN timestamp "<<int(i.header.boardId ) <<" CAEN board number "<<std::endl;
	if(filltree==true){
		CAENFragType= int(i.header.fragmentType );
		CAENID=int(i.header.boardId);
		CAENUnixTime=int(i.header.timeStampSec);
		CAENTrigTimeTag=double(i.header.triggerTimeTag*(8e-9));
		CAENChannels=int(i.header.nChannels);
		CAENSamples=int(i.header.nSamples);
		CAENTimeDiff=CAENUnixTime-CAENTrigTimeTag;
		CAENADC.clear();
		CAENADC.push_back(-1);


		t->Fill();
		CAENFragType=-1;
		CAENID=-1;
		CAENUnixTime=0;
		CAENTrigTimeTag=0.;
		CAENChannels=0;
		CAENTimeDiff=0;
		}
		
 }//caen fragment loop
//end of CAEN
//TDC


 // TH2D * profile [TDCDriver::MAX_CHAMBERS];
  //TH1D * profileX [TDCDriver::MAX_CHAMBERS];
  //TH1D * profileY [TDCDriver::MAX_CHAMBERS];
  //TH1D * profileXhits [TDCDriver::MAX_CHAMBERS];
  //TH1D * profileYhits [TDCDriver::MAX_CHAMBERS];
  //TH1D * hitDeltaT[TDCDriver::MAX_CHAMBERS];
  //uint32_t offset[TDCDriver::MAX_TDCS] = {62,62,63,63,70,70,72,70,78,78,80,82,82,81,81,81};
 // uint32_t low[TDCDriver::MAX_TDCS];
  //uint32_t high[TDCDriver::MAX_TDCS];

  for ( int tdc = 0; tdc < TDCFragment::MAX_TDCS; tdc++)
  {
   // low[tdc]  = offset[tdc] - TIME_WINDOW;
   // high[tdc] = offset[tdc] + TIME_WINDOW;
  }

  //matchesPerEvent = new TH1D("Matches per event","Matches per event",100,-0.5,99.5);

  for ( int i=0; i<TDCFragment::MAX_CHAMBERS; i++)
  {
    char title[256];
    sprintf(title,"Matches_WC%d",(i+1));
  //  matchesChamber[i] = new TH1D(title,title,100,-0.5,99.5);

    sprintf(title,"WC%d_Profile", (i+1));
   // profile[i] = new TH2D(title,title,128,-0.5,127.5,128,-0.5,127.5);

    sprintf(title,"WC%d_X_Profile", (i+1));
  //  profileX[i] = new TH1D(title,title,128,-0.5,127.5);

    sprintf(title,"WC%d_Y_Profile", (i+1));
    //profileY[i] = new TH1D(title,title,128,-0.5,127.5);

    sprintf(title,"WC%d_Xhits_Profile", (i+1));
   // profileXhits[i] = new TH1D(title,title,128,-0.5,127.5);

    sprintf(title,"WC%d_Yhits_Profile", (i+1));
   // profileYhits[i] = new TH1D(title,title,128,-0.5,127.5);

    sprintf(title,"WC%d_hitDeltaT", (i+1));
   // hitDeltaT[i] = new TH1D(title,title,100,-50.5,49.5);
  }



for(int chb=0;chb<4;chb++){
	_tdchitsX[chb].clear();
	_tdchitsY[chb].clear();
	_tdchitsX[chb].resize(129);
	_tdchitsY[chb].resize(129);
	
	for(int c1=0;c1<129;c1++){
		_tdchitsX[chb][c1].clear();
		_tdchitsY[chb][c1].clear();
		}
	}
	

    int ind2=0;
for(ind2=0;ind2<4;ind2++){
      _tdcXY[ind2].reset( new TH2D( Form("tdc_plane_%d_spill_%d_xy", ind2, spillNumber), "",
								      128, -0.5, 
								      128 - 0.5, 128,
								      -0.5, 128 - 0.5 ) );
}

  for ( auto &td: data->tdcFrags )
    {

    	if (data->tdcFrags.size()>0) filltree=true;
      int events = 0;
      //	int tdc1=0;
      for (auto &i: td.tdcEvents )
      {
		if ( td.controllerHeader.nTDCs != i.size())
	{
	  std::cout << "*** Fatal nTDCs mismatch " << i.size() << " != " << 
	    td.controllerHeader.nTDCs << std::endl;

	}
	
		if(filltree==true){
		NTDCs=0;
		TDCTrigCounts=0;
		TDCControllerNumber=0;
		
		TDCSpillCounter=0;
		TDCStatus=0;
		TDCLinkStatus=0;
		NTDCs=int(td.controllerHeader.nTDCs );
		TDCTrigCounts=int(td.controllerHeader.triggerCounts );
		TDCControllerNumber=static_cast<int>(td.controllerHeader.controllerNumber );

		TDCSpillCounter=int(td.controllerHeader.spillCounter );
		TDCStatus=int(td.controllerHeader.tdcStatus );
		TDCLinkStatus=int(td.controllerHeader.linkStatus );
		

		NTDCs=0;
		TDCTrigCounts=0;
		TDCControllerNumber=0;

		TDCSpillCounter=0;
		TDCStatus=0;
		TDCLinkStatus=0;
		
/*
		TDCTime=double(tdce.TDCTimestamp()*1.177e-9);

		TDCFragType=int(tdce.getHeader()->fragmentType );
		TDCControllerTimeInt=uint64_t(tdce.getHeader()->controllerTimeStamp );
		TDCTimeInt=uint64_t(tdce.getHeader()->tdcTimeStamp);
//std::cout<<" "<<TDCNR<<std::endl;
//std::cout<<std::hex << TDCTimeInt<<std::endl;
		TDCNewTimeInt=(TDCTimeInt<<3)+(TDCControllerTimeInt&0x7)*/
		}

		// Here "i" is std::vector<TdcEventData> which should have one/TDC
	// Next loop over TDCs within the event - Bill Badgett
		for ( int chamber=0; chamber<TDCFragment::MAX_CHAMBERS; chamber++)
		{
			//int matchesPerChamber = 0;
	  		for ( int tdc=0; tdc<TDCFragment::TDCS_PER_CHAMBER; tdc++)
	 		{
	 			int tdcGlobal = chamber * TDCFragment::MAX_CHAMBERS + tdc;	
	    			TDCFragment::TdcEventData data = i.at(tdcGlobal);
	    				    if ( data.tdcEventHeader.nHits > 0 )
	    {
	      uint64_t trigger = ((uint64_t)data.tdcEventHeader.tdcTimeStamp << 3 ) | 
		( (uint64_t)data.tdcEventHeader.controllerTimeStamp &0x7);
	      TDCNewTime=(double)trigger / 1.177E09;
	    }
		t->Fill();
	    			for ( auto &h: data.tdcHits )
	    			{
	      				tdcHits[tdcGlobal]->Fill( (double)h.timeBin );
	      				tdcHitssum[tdcGlobal]->Fill( (double)h.timeBin );
					int channel_tmp=0;
					int timebin_tmp=0;
					channel_tmp=(int)h.channel;
					timebin_tmp=(int)h.timeBin;
					std::cout<<"filling wire chamber data channel "<<channel_tmp<<" timebin "<<timebin_tmp<<" tdcNR " <<tdcGlobal<<std::endl;
					//tdc1=tdcGlobal;
					_tdcHitTime[tdcGlobal]=timebin_tmp*1.177e-9;
					if(tdcGlobal==1){
					_tdchitsX[0][channel_tmp].push_back(timebin_tmp);
					_tdchitsX[0][128].push_back(0);
		
					}
					if(tdcGlobal==2){
					_tdchitsX[0][channel_tmp+TDCFragment::N_CHANNELS].push_back(timebin_tmp);
					_tdchitsX[0][128].push_back(0);
		

					}
					if(tdcGlobal==3){
					_tdchitsY[0][TMath::Abs(channel_tmp-63)+TDCFragment::N_CHANNELS].push_back(timebin_tmp);
					_tdchitsY[0][128].push_back(0);
		
					}
					if(tdcGlobal==4){
					_tdchitsY[0][TMath::Abs(channel_tmp-63)].push_back(timebin_tmp);
					_tdchitsY[0][128].push_back(0);
		
					}
					if(tdcGlobal==5){
					_tdchitsX[1][channel_tmp].push_back(timebin_tmp);
					_tdchitsX[1][128].push_back(1);
					}
					if(tdcGlobal==6){
					_tdchitsX[1][channel_tmp+TDCFragment::N_CHANNELS].push_back(timebin_tmp);
					_tdchitsX[1][128].push_back(1);
					}
					if(tdcGlobal==7){
					_tdchitsY[1][TMath::Abs(channel_tmp-63)+TDCFragment::N_CHANNELS].push_back(timebin_tmp);
					_tdchitsY[1][128].push_back(1);
					}
					if(tdcGlobal==8){
					_tdchitsY[1][TMath::Abs(channel_tmp-63)].push_back(timebin_tmp);
					_tdchitsY[1][128].push_back(1);
					}
					if(tdcGlobal==9){
					_tdchitsX[2][channel_tmp].push_back(timebin_tmp);
					_tdchitsX[2][128].push_back(2);
					}
					if(tdcGlobal==10){
					_tdchitsX[2][channel_tmp+TDCFragment::N_CHANNELS].push_back(timebin_tmp);
					_tdchitsX[2][128].push_back(2);
					}
					if(tdcGlobal==11){
					_tdchitsY[2][TMath::Abs(channel_tmp-63)+TDCFragment::N_CHANNELS].push_back(timebin_tmp);
					_tdchitsY[2][128].push_back(2);
					}
					if(tdcGlobal==12){
					_tdchitsY[3][TMath::Abs(channel_tmp-63)].push_back(timebin_tmp);
					_tdchitsY[3][128].push_back(2);
					}
					if(tdcGlobal==13){
					_tdchitsX[3][channel_tmp].push_back(timebin_tmp);
					_tdchitsX[3][128].push_back(3);
					}
					if(tdcGlobal==14){
					_tdchitsX[3][channel_tmp+TDCFragment::N_CHANNELS].push_back(timebin_tmp);
					_tdchitsX[3][128].push_back(3);
					}
					if(tdcGlobal==15){
					_tdchitsY[3][TMath::Abs(channel_tmp-63)+TDCFragment::N_CHANNELS].push_back(timebin_tmp);
					_tdchitsY[3][128].push_back(3);
					}
					if(tdcGlobal==16){
					_tdchitsY[3][TMath::Abs(channel_tmp-63)].push_back(timebin_tmp);
					_tdchitsY[3][128].push_back(3);
					}
	    					}//loop over hits
							    		
	 			}//loop over tdcs in chamber
	
			}//loop over the tdc chambers in event

		}//loop over the vector of tdc events
			
		events++;
	
	}//loop over tdc fragments


	
	std::cout<<_tdchitsX.size()<<" is the chambers number, now checking the channels for x axis in chamber 2 "<<_tdchitsX[1].size()<<std::endl;
	//hits matching
	uint32_t  chamber2=0;
	uint32_t  i2=0;
	uint32_t  j2=0;
	uint32_t  ii=0;
	uint32_t  jj=0;
double time_difference2=5;
	for(chamber2=0;chamber2<4;chamber2++){
		time_difference=10;
		
		// TSpectrum *s = new TSpectrum(200);
  		// s->Search(tdcHitssum[((chamber2+1)*4) -3],20,"nobackground",0.5);
  		
  		 tdcHitssum[((chamber2+1)*4) -3]->GetXaxis()->SetRange(0,175);
		window_low=tdcHitssum[((chamber2+1)*4) -3]->GetBinCenter(tdcHitssum[((chamber2+1)*4) -1]->GetMaximumBin())-time_difference;
		
				//window_low=s->GetPositionX()[0]-time_difference;
		tdcHitssum[((chamber2+1)*4) -3]->GetXaxis()->SetRange(0,175);
				window_high=tdcHitssum[((chamber2+1)*4) -3]->GetBinCenter(tdcHitssum[((chamber2+1)*4) -1]->GetMaximumBin())+time_difference;
				//window_high=s->GetPositionX()[0]+time_difference;
				if(window_low<130 || window_high>200){
				 window_low=150;
				 window_high=170;
				 }
			tdcHitWindows[((chamber2+1)*4) -3]->Fill(window_high);	
			tdcHitWindows[((chamber2+1)*4) -3]->Fill(window_low);
		i2=0;
		for(i2=0;i2<128;i2++){
			//std::cout<<"LINE 590 size of hits for channel "<<i2<<" in chamber "<<chamber2 <<" hits number "<<_tdchitsX[chamber2][i2].size()<<" size of vector for this chamber "<<_tdchitsX[chamber2].size()<<std::endl;
				ii=0;
				for(ii=0;ii<_tdchitsX[chamber2][i2].size();ii++){
					j2=0;
					for(j2=0;j2<128;j2++){
						jj=0;
						for(jj=0;jj<_tdchitsY[chamber2][j2].size();jj++){
							//std::cout<<jj<<" "<<ii<<" "<<i2 <<" "<<j2<<std::endl;
							if((_tdchitsX[chamber2][i2][ii]<window_high)&&(_tdchitsX[chamber2][i2][ii]>window_low)&&(_tdchitsY[chamber2][j2][jj]>window_low)&&(_tdchitsY[chamber2][j2][jj]<window_high)){
							if((_tdchitsY[chamber2][j2][jj]!=-1 && _tdchitsX[chamber2][i2][ii]!=-1) && (_tdchitsY[chamber2][j2][jj]<=(_tdchitsX[chamber2][i2][ii]+time_difference2) )&& (_tdchitsY[chamber2][j2][jj]>=(_tdchitsX[chamber2][i2][ii]-time_difference2) )){
							
							_tdcXY[int(chamber2)]->Fill(i2,j2);
							_tdcXYsum[int(chamber2)]->Fill(i2,j2);
							_tdchitsX[chamber2][i2][ii]=-1;//replace values with -1 to avoid double match
							_tdchitsY[chamber2][j2][jj]=-1;
							} //comparison of timing in the timebin for different planes
								}//window
							}//loop over hit times in y
						} //loop over channels in y
					} //loop over hit times in channel in x
	
		}//loop over channels in x
	//delete s;	
	}//loop over chambers
std::cout<<"reconstruction of xy hits done"<<std::endl;
for(int ind3=0;ind3<4;ind3++){
  if ( _tdcXYsum[ind3] != NULL ){

    	 _tdcXYsum[ind3]->Write("",TObject::kOverwrite);
    	 
  	// _tdcXY[ind3]->Write();
  	// _tdcXY[ind3]->Print();
  	}
}

  for ( int i=0; i<TDCFragment::MAX_TDCS; i++)
  {
tdcHits[i]->Write("",TObject::kOverwrite);
tdcHitssum[i]->Write("",TObject::kOverwrite);
tdcHitWindows[i]->Write("",TObject::kOverwrite);
  
  }

//END of TDC
//WUT
filltree=false;
    if (raw->size() != 1 ) {
      throw cet::exception("Error in EVB WUT module: expected one and only one spill fragment");
    }
    	   const int nfrag_wut=data->wutFrags.size();
  std::cout<<"Found "<<nfrag_wut<<" wut fragments"<<std::endl;
    	  if (nfrag_wut>0) filltree=true;
  for (auto &i: data->wutFrags )
  {
	//bb.printHeader();
	if(filltree==true){
		WUTFragType=int(i.header.fragmentType);
		WUTTime=Double_t((i.header.timeHeader)*(16.0e-6));
		WUTHits=int(i.header.nHits);
		WUTHitTime0.clear();
		WUTHitTime1.clear();
		WUTHitTime2.clear();
		WUTHitTime3.clear();
		WUTHitTime4.clear();
		WUTHitTime5.clear();
		WUTHitTime6.clear();
		WUTHitTime7.clear();
		WUTHitTime8.clear();
		WUTHitTime9.clear();
		WUTHitTime10.clear();
		WUTHitTime11.clear();
		WUTHitTime12.clear();
		WUTHitTime13.clear();
		WUTHitTime14.clear();
		WUTHitTime15.clear();
		int i_wut = 0;
		for ( auto &j: i.hits )
		{
		  float time_t=float(j.timeBin);
			int channel_t=static_cast<int>( j.channel );
			//std::cout<<"channel "<<channel_t<<" nhits "<<uint32_t(bb.getHeader()->nHits)<<std::endl;
			switch(channel_t){
				case 0:
					WUTHitTime0.push_back(time_t);
					break;
				case 1:
					WUTHitTime1.push_back(time_t);
					break;
				case 2:
					WUTHitTime2.push_back(time_t);
					break;
				case 3:
					WUTHitTime3.push_back(time_t);
					break;
				case 4:
					WUTHitTime4.push_back(time_t);
					break;
				case 5:
					WUTHitTime5.push_back(time_t);
					break;
				case 6:
					WUTHitTime6.push_back(time_t);
					break;
				case 7:
					WUTHitTime7.push_back(time_t);
					break;
				case 8:
					WUTHitTime8.push_back(time_t);
					break;
				case 9:
					WUTHitTime9.push_back(time_t);
					break;
				case 10:
					WUTHitTime10.push_back(time_t);
					break;
				case 11:
					WUTHitTime11.push_back(time_t);
					break;
				case 12:
					WUTHitTime12.push_back(time_t);
					break;
				case 13:
					WUTHitTime13.push_back(time_t);
					break;
				case 14:
					WUTHitTime14.push_back(time_t);
					break;
				case 15:
					WUTHitTime15.push_back(time_t);
					break;
				default: std::cout<<" wrong channel number "<<channel_t<<std::endl;
				//t->Fill();

			}
	

			i_wut++;
       		}

			//std::cout<<WUTHits<<" WUT HITS  -tree filled fragtype "<<WUTFragType<<std::endl;
			t->Fill();
			WUTFragType=-1;
			WUTTime=0;
			WUTHits=0;
		


		}

	//      std::cout << std::endl;
    }//wut fragment loop
filltree=false;
//END OF WUT
//v1495
filltree=false;
    if (raw->size() != 1 ) {
      throw cet::exception("Error in V1495Dump EVB: expected one and only one spill fragment");
    }
    
    const auto& frag95((*raw)[0]);

    std::vector<const uint8_t*> lariatFragPtrs95;

    LariatFragment::LariatFragmentType lariatFragType95 = LariatFragment::LariatFragmentType::FRAGMENT_TYPE_V1495;

    getLariatFragments(frag95, 
     		       lariatFragType95,
		       lariatFragPtrs95
		       );

    std::cout << std::endl;
    std::cout << "Run " << e.run() << ", subrun " << e.subRun()
       	      << ", spill " << spillNumber << " has " << lariatFragPtrs95.size()
   	      << " fragment(s) of type " << lariatFragType95 << std::endl;
            if (lariatFragPtrs95.size()>0) filltree=true;
    for (size_t idx = 0; idx < lariatFragPtrs95.size(); ++idx) {

      lariat::V1495HitFragment bc( lariatFragPtrs95[idx]  );

      bc.printHeader();

      std::cout << std::endl;

	if(filltree==true){
		v1495FragType=int(bc.getHeader()->fragmentType);
		v1495Channels=int(Double_t(bc.getHeader()->nChan));
		v1495TrigPatterns=int(bc.getHeader()->nTrigPat);
		v1495VetoPatterns=int(bc.getHeader()->nVetoPat);

		t->Fill();
		v1495FragType=-1;
		v1495Channels=0;
		v1495TrigPatterns=0;
		v1495VetoPatterns=0;
		}


    }
filltree=false;
//end of v1495
  }

  std::cout << std::endl;


t->Write();
f->Close();
}
/*
void lariat::EVB::beginRun(art::Run const &e) { 

  std::cerr << "John, 7/7/14: need to augment run # checking logic in beginRun() function" << std::endl;
  if (e.run () == current_run_) return;
  current_run_ = e.run ();


}
*/
DEFINE_ART_MODULE(lariat::EVB)
